/*
** HDL4SE: VerilogۺϷƽ̨
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: ģ
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/


/*
* counter.c
    202105180851: rxh, initial version
*/
#include "stdlib.h"
#include "stdio.h"

#include "object.h"
#include "bignumber.h"
#include "hdl4secell.h"

static IHDL4SEUnit** hdl4seCreateDec2seg(IHDL4SEModule** parent, char* instanceparam, char* name) { /* module dec2seg */
	IHDL4SEUnit** wire_const[11];
	IHDL4SEUnit** unit_const[11];
	IHDL4SEUnit** unit_mux16 = NULL;
	IHDL4SEModule** module_dec2seg = NULL;
	IHDL4SEUnit** unit_dec2seg = NULL;
	int i;
	char temp[128];
	char* constparam[11] = {
		"8, 8'b00111111",
		"8, 8'b00000110",
		"8, 8'b01011011",
		"8, 8'b01001111",
		"8, 8'b01100110",
		"8, 8'b01101101",
		"8, 8'b01111101",
		"8, 8'b00000111",
		"8, 8'b01111111",
		"8, 8'b01101111",
		"8, 8'b01111001"
	};

	/* ģ */
	unit_dec2seg = hdl4seCreateUnit(parent, CLSID_HDL4SE_MODULE, instanceparam, name);
	/* õIHDL4SEModule ӿ */
	objectQueryInterface(unit_dec2seg, IID_HDL4SEMODULE, (void **)&module_dec2seg);
	/* Ӷ˿ */
	objectCall3(module_dec2seg, AddPort, 4, PORTTYPE_INPUT,  "0.dec");
	objectCall3(module_dec2seg, AddPort, 8, PORTTYPE_OUTPUT, "1.seg");

	for (i = 0; i < 11; i++) {
		char tempname[32];
		sprintf(tempname, "wire_cst%d", i);
		wire_const[i] = hdl4seCreateUnit(module_dec2seg, CLSID_HDL4SE_WIRE, "8", tempname);
		sprintf(tempname, "const_cst%d", i);
		unit_const[i] = hdl4seCreateUnit(module_dec2seg, CLSID_HDL4SE_CONST, constparam[i], tempname);
		objectCall3(wire_const[i], Connect, 0, unit_const[i], 0);
	}
	/* ѡunit_mux */
	unit_mux16 = hdl4seCreateUnit(module_dec2seg, CLSID_HDL4SE_MUX16, "8", "mux_dec");
	/*muxӵ˿decconstall*/
	objectCall3(unit_mux16, Connect, 0, unit_dec2seg, 0);
	for (i = 0; i < 10; i++) {
		objectCall3(unit_mux16, Connect, i+1, wire_const[i], 0);
	}
	for (; i < 16; i++) {
		objectCall3(unit_mux16, Connect, i + 11, wire_const[10], 0);
	}
	/* ģsegӵ*/
	objectCall3(unit_dec2seg, Connect, 1, unit_mux16, 17);

	/*ͷmoduleӿ*/
	objectRelease(module_dec2seg);
	/*unitӿ*/
	return unit_dec2seg;
}

static IHDL4SEUnit** hdl4seCreateCounter(IHDL4SEModule** parent, char* instanceparam, char* name) { /* module counter */
	IHDL4SEModule** module_counter = NULL;
	IHDL4SEUnit** unit_counter = NULL;
	int width, maxvalue, resetvalue;
	char temp[128];
	sscanf_s(instanceparam, "%d, %d, %d", &width, &maxvalue, &resetvalue);
	/* ģ */
	unit_counter = hdl4seCreateUnit(parent, CLSID_HDL4SE_MODULE, instanceparam, name);
	/* õIHDL4SEModule ӿ */
	objectQueryInterface(unit_counter, IID_HDL4SEMODULE, (void **)&module_counter);
	/* Ӷ˿ */
	objectCall3(module_counter, AddPort, 1, PORTTYPE_INPUT, "0.nwReset");
	objectCall3(module_counter, AddPort, 1, PORTTYPE_INPUT, "1.wCounterIt");
	objectCall3(module_counter, AddPort, width, PORTTYPE_OUTPUT, "2.bCouter");
	objectCall3(module_counter, AddPort, 1, PORTTYPE_OUTPUT, "3.wCounterOverflow");

	/*WIDTHȵļĴֵ*/
	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_wirein_bCurrentCounter = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "wirein_bCurrentCounter");
	IHDL4SEUnit** wire_wireout_bCurrentCounter = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "wireout_bCurrentCounter");
	IHDL4SEUnit** reg_bCurrentCounter = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_REG, temp, "bCurrentCounter");
	/*Ĵһ*/
	objectCall3(reg_bCurrentCounter, Connect, 0, wire_wirein_bCurrentCounter, 0);
	objectCall3(wire_wireout_bCurrentCounter, Connect, 0, reg_bCurrentCounter, 1);
	objectCall3(unit_counter, Connect, 2, wire_wireout_bCurrentCounter, 0);

	/*һĴʾǷ*/
	IHDL4SEUnit** wire_wirein_wOverflow = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wirein_wOverflow");
	IHDL4SEUnit** wire_wireout_wOverflow = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wireout_wOverflow");
	IHDL4SEUnit** reg_wOverflow = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_REG, "1, 0", "wOverflow");
	/*Ĵһ*/
	objectCall3(reg_wOverflow, Connect, 0, wire_wirein_wOverflow, 0);
	objectCall3(wire_wireout_wOverflow, Connect, 0, reg_wOverflow, 1);
	objectCall3(unit_counter, Connect, 3, wire_wireout_wOverflow, 0);

	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bConst_MAXVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bConst_MAXVALUE");
	sprintf(temp, "%d, %d", width, maxvalue);
	IHDL4SEUnit** unit_const_MAXVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_CONST, temp, "const_MAXVALUE");
	objectCall3(wire_bConst_MAXVALUE, Connect, 0, unit_const_MAXVALUE, 0);

	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bConst_RESETVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bConst_RESETVALUE");
	sprintf(temp, "%d, %d", width, resetvalue);
	IHDL4SEUnit** unit_const_RESETVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_CONST, temp, "const_RESETVALUE");
	objectCall3(wire_bConst_RESETVALUE, Connect, 0, unit_const_RESETVALUE, 0);

	IHDL4SEUnit** wire_wEQ_bCurrentCounter_MAXVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wEQ_bCurrentCounter_MAXVALUE");

	sprintf(temp, "%d, %d, 1, %d", width, width, BINOP_EQ);
	IHDL4SEUnit** unit_binop_EQ_bCurrentCounter_MAXVALUE = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_BINOP, temp, "binop_EQ_bCurrentCounter_MAXVALUE");
	objectCall3(unit_binop_EQ_bCurrentCounter_MAXVALUE, Connect, 0, wire_wireout_bCurrentCounter, 0);
	objectCall3(unit_binop_EQ_bCurrentCounter_MAXVALUE, Connect, 1, wire_bConst_MAXVALUE, 0);
	objectCall3(wire_wEQ_bCurrentCounter_MAXVALUE, Connect, 0, unit_binop_EQ_bCurrentCounter_MAXVALUE, 2);

	/* bCurrentCounter+1 üӷʵ */
	  /*  1 */
	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bConst_One = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bConst_One");
	sprintf(temp, "%d, %d", width, 1);
	IHDL4SEUnit** unit_const_One = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_CONST, temp, "const_One");
	objectCall3(wire_bConst_One, Connect, 0, unit_const_One, 0);

	/* bCurrentCounter + 1 */
	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bCurrentCounterPlusOne = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bCurrentCounterPlusOne");
	sprintf(temp, "%d, %d, 1, %d", width, width, BINOP_ADD);
	IHDL4SEUnit** unit_binop_bCurrentCounterPlusOne = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_BINOP, temp, "binop_bCurrentCounterInc");
	objectCall3(unit_binop_bCurrentCounterPlusOne, Connect, 0, wire_wireout_bCurrentCounter, 0);
	objectCall3(unit_binop_bCurrentCounterPlusOne, Connect, 1, wire_bConst_One, 0);
	objectCall3(wire_bCurrentCounterPlusOne, Connect, 0, unit_binop_bCurrentCounterPlusOne, 2);

	/* ifѡʵ */
	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bCurrentCounter_if_wCounterIt = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bCurrentCounter_if_wCounterIt");
	IHDL4SEUnit** unit_muxCurrentCouter = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, temp, "mux_bCurrentCounter_if_wCounterIt");
	objectCall3(unit_muxCurrentCouter, Connect, 0, wire_wEQ_bCurrentCounter_MAXVALUE, 0);
	objectCall3(unit_muxCurrentCouter, Connect, 1, wire_bCurrentCounterPlusOne, 0);
	objectCall3(unit_muxCurrentCouter, Connect, 2, wire_bConst_RESETVALUE, 0);
	objectCall3(wire_bCurrentCounter_if_wCounterIt, Connect, 0, unit_muxCurrentCouter, 3);

	IHDL4SEUnit** wire_wConst_0 = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wConst_0");
	IHDL4SEUnit** unit_const_0 = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_CONST, "1, 0", "const_0");
	objectCall3(wire_wConst_0, Connect, 0, unit_const_0, 0);

	IHDL4SEUnit** wire_wConst_1 = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wConst_1");
	IHDL4SEUnit** unit_const_1 = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_CONST, "1, 1", "const_1");
	objectCall3(wire_wConst_1, Connect, 0, unit_const_1, 0);

	IHDL4SEUnit** wire_wOverflow_if_wCounterIt = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wOverflow_if_wCounterIt");
	IHDL4SEUnit** unit_mux_wOverflow_if_wCounterIt = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, "1", "mux_wOverflow_if_wCounterIt");
	objectCall3(unit_mux_wOverflow_if_wCounterIt, Connect, 0, wire_wEQ_bCurrentCounter_MAXVALUE, 0);
	objectCall3(unit_mux_wOverflow_if_wCounterIt, Connect, 1, wire_wConst_0, 0);
	objectCall3(unit_mux_wOverflow_if_wCounterIt, Connect, 2, wire_wConst_1, 0);
	objectCall3(wire_wOverflow_if_wCounterIt, Connect, 0, unit_mux_wOverflow_if_wCounterIt, 3);

	sprintf(temp, "%d", width);
	IHDL4SEUnit** wire_bCurrentCounter_if_nwReset = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, temp, "bCurrentCounter_if_nwReset");
	IHDL4SEUnit** unit_mux_bCurrentCounter_if_nwReset = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, temp, "mux_bCurrentCounter_if_nwReset");
	objectCall3(unit_mux_bCurrentCounter_if_nwReset, Connect, 0, module_counter, 1);
	objectCall3(unit_mux_bCurrentCounter_if_nwReset, Connect, 1, wire_wireout_bCurrentCounter, 0);
	objectCall3(unit_mux_bCurrentCounter_if_nwReset, Connect, 2, wire_bCurrentCounter_if_wCounterIt, 0);
	objectCall3(wire_bCurrentCounter_if_nwReset, Connect, 0, unit_mux_bCurrentCounter_if_nwReset, 3);

	IHDL4SEUnit** wire_wOverflow_if_nwReset = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_WIRE, "1", "wOverfloat_if_nwReset");
	IHDL4SEUnit** unit_mux_wOverflow_if_nwReset = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, "1", "mux_wOverflow_if_nwReset");
	objectCall3(unit_mux_wOverflow_if_nwReset, Connect, 0, module_counter, 1);
	objectCall3(unit_mux_wOverflow_if_nwReset, Connect, 1, wire_wireout_wOverflow, 0);
	objectCall3(unit_mux_wOverflow_if_nwReset, Connect, 2, wire_wOverflow_if_wCounterIt, 0);
	objectCall3(wire_wOverflow_if_nwReset, Connect, 0, unit_mux_wOverflow_if_nwReset, 3);

	IHDL4SEUnit** unit_mux_bCurrentCounter = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, temp, "mux_bCurrentCounter");
	objectCall3(unit_mux_bCurrentCounter, Connect, 0, module_counter, 1);
	objectCall3(unit_mux_bCurrentCounter, Connect, 1, wire_bConst_RESETVALUE, 0);
	objectCall3(unit_mux_bCurrentCounter, Connect, 2, wire_bCurrentCounter_if_nwReset, 0);
	objectCall3(wire_wirein_bCurrentCounter, Connect, 0, unit_mux_bCurrentCounter, 3);

	IHDL4SEUnit** unit_mux_wOverflow = hdl4seCreateUnit(module_counter, CLSID_HDL4SE_MUX2, "1", "mux_wOverflow");
	objectCall3(unit_mux_wOverflow, Connect, 0, module_counter, 1);
	objectCall3(unit_mux_wOverflow, Connect, 1, wire_wireout_wOverflow, 0);
	objectCall3(unit_mux_wOverflow, Connect, 2, wire_wOverflow_if_wCounterIt, 0);
	objectCall3(wire_wirein_wOverflow, Connect, 0, unit_mux_wOverflow, 3);

	/*ͷmoduleӿ*/
	objectRelease(module_counter);
	/*unitӿ*/
	return unit_counter;

}

IHDL4SEUnit** hdl4seCreateMain(IHDL4SEModule** parent, char* instanceparam, char* name) 
{ /* module main */
	IHDL4SEModule** module_main = NULL;
	IHDL4SEUnit** unit_main = NULL;
	char temp[128];
	int i;
	/* ģ */
	unit_main = hdl4seCreateUnit(parent, CLSID_HDL4SE_MODULE, instanceparam, name);
	/* õIHDL4SEModule ӿ */
	objectQueryInterface(unit_main, IID_HDL4SEMODULE, (void **)&module_main);
	/* Ӷ˿ */
	objectCall3(module_main, AddPort, 1, PORTTYPE_INPUT, "0.nwReset");
	objectCall3(module_main, AddPort, 1, PORTTYPE_OUTPUT, "1.wWrite");
	objectCall3(module_main, AddPort, 32, PORTTYPE_OUTPUT, "2.bWriteAddr");
	objectCall3(module_main, AddPort, 32, PORTTYPE_OUTPUT, "3.bWriteData");
	objectCall3(module_main, AddPort, 4, PORTTYPE_OUTPUT, "4.bWriteMask");
	objectCall3(module_main, AddPort, 1, PORTTYPE_OUTPUT, "5.wRead");
	objectCall3(module_main, AddPort, 32, PORTTYPE_OUTPUT, "6.bReadAddr");
	objectCall3(module_main, AddPort, 32, PORTTYPE_INPUT, "7.bReadData");

	IHDL4SEUnit** wire_wButton0Pressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wButton0Pressed");
	IHDL4SEUnit** wire_wButton1Pressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wButton1Pressed");
	IHDL4SEUnit** wire_wButton2Pressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wButton2Pressed");

	IHDL4SEUnit** const_0_wRead = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "1, 1", "const_0_wRead");
	objectCall3(unit_main, Connect, 5, const_0_wRead, 0);

	IHDL4SEUnit** const_bReadAddr = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "32, 32'hF000_0000", "const_bReadAddr");
	objectCall3(unit_main, Connect, 6, const_bReadAddr, 0);

	IHDL4SEUnit** split_bReadData_wButton012 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_SPLIT4, "32, 1, 0, 1, 1, 1, 2, 1, 3", "bReadData_wButton012");
	objectCall3(split_bReadData_wButton012, Connect, 0, unit_main, 7);
	objectCall3(wire_wButton0Pressed, Connect, 0, split_bReadData_wButton012, 1);
	objectCall3(wire_wButton1Pressed, Connect, 0, split_bReadData_wButton012, 2);
	objectCall3(wire_wButton2Pressed, Connect, 0, split_bReadData_wButton012, 3);
	/* split_bReadData_wButton012ĵĽŲ */

	IHDL4SEUnit** wire_nwResetCount = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "nwResetCount");
	
	IHDL4SEUnit** wire_wCounterin[10];
	for (i = 0; i < 10; i++) {
		sprintf(temp, "wCounterin0%d", i);
		wire_wCounterin[i] = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", temp);
	}

	IHDL4SEUnit** wire_bCount[10];
	for (i = 0; i < 10; i++) {
		sprintf(temp, "bCount0%d", i);
		wire_bCount[i] = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", temp);
	}

	IHDL4SEUnit** counter_counter[10];
	for (i = 0; i < 10; i++) {
		sprintf(temp, "counter%d", i);
		counter_counter[i] = hdl4seCreateCounter(module_main, "4, 9, 0", temp);
		objectCall3(counter_counter[i], Connect, 0, wire_nwResetCount, 0);
		objectCall3(counter_counter[i], Connect, 1, wire_wCounterin[i], 0);
		objectCall3(wire_bCount[i], Connect, 0, counter_counter[i], 2);
		if (i<9)
			objectCall3(wire_wCounterin[i+1], Connect, 0, counter_counter[i], 3);
	}

	IHDL4SEUnit** wire_wirein_wCounterIt = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wirein_wCounterIt");
	IHDL4SEUnit** wire_wireout_wCounterIt = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wireout_wCounterIt");
	IHDL4SEUnit** reg_wCounterIt = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "1", "wCounterIt");
	/*Ĵһ*/
	objectCall3(reg_wCounterIt, Connect, 0, wire_wirein_wCounterIt, 0);
	objectCall3(wire_wireout_wCounterIt, Connect, 0, reg_wCounterIt, 1);
	objectCall3(wire_wCounterin[0], Connect, 0, wire_wireout_wCounterIt, 0);

	IHDL4SEUnit** wire_wButton0NotPressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wButton0NotPressed");
	sprintf(temp, "1, 1, %d", UNOP_NOT);
	IHDL4SEUnit** unop_Button0NotPressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_UNOP, temp, "unop_Button0NotPressed");
	objectCall3(unop_Button0NotPressed, Connect, 0, wire_wButton0Pressed, 0);
	objectCall3(wire_wButton0NotPressed, Connect, 0, unop_Button0NotPressed, 1);

	IHDL4SEUnit** wire_wButton1NotPressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wButton1NotPressed");
	sprintf(temp, "1, 1, %d", UNOP_NOT);
	IHDL4SEUnit** unop_Button1NotPressed = hdl4seCreateUnit(module_main, CLSID_HDL4SE_UNOP, temp, "unop_Button1NotPressed");
	objectCall3(unop_Button1NotPressed, Connect, 0, wire_wButton1Pressed, 0);
	objectCall3(wire_wButton1NotPressed, Connect, 0, unop_Button1NotPressed, 1);

	sprintf(temp, "1, 1, 1, %d", BINOP_AND);
	IHDL4SEUnit** binop_binop_counterit = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "binop_counterit");
	objectCall3(binop_binop_counterit, Connect, 0, wire_wButton1NotPressed, 0);
	objectCall3(binop_binop_counterit, Connect, 1, wire_wButton2Pressed, 0);
	objectCall3(wire_wirein_wCounterIt, Connect, 0, binop_binop_counterit, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_AND);
	IHDL4SEUnit** binop_binop_resetcounter = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "binop_resetcounter");
	objectCall3(binop_binop_resetcounter, Connect, 0, wire_wButton0NotPressed, 0);
	objectCall3(binop_binop_resetcounter, Connect, 1, unit_main, 0);
	objectCall3(wire_nwResetCount, Connect, 0, binop_binop_resetcounter, 2);

	/* ӣʮӦʮ */
	IHDL4SEUnit** code[10];
	IHDL4SEUnit** dec[10];
	for (i = 0; i < 10; i++) {
		sprintf(temp, "code%d", i);
		code[i] = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "8", temp);
		sprintf(temp, "dec%d", i);
		dec[i] = hdl4seCreateDec2seg(module_main, "", temp);
		objectCall3(dec[i], Connect, 0, wire_bCount[i], 0);
		objectCall3(code[i], Connect, 0, dec[i], 1);
	}

	IHDL4SEUnit** wire_wCounterin98 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin98");
	IHDL4SEUnit** wire_wCounterin76 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin76");
	IHDL4SEUnit** wire_wCounterin54 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin54");
	IHDL4SEUnit** wire_wCounterin32 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin32");
	IHDL4SEUnit** wire_wCounterin10 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin10");
	IHDL4SEUnit** wire_wCounterin7654 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin7654");
	IHDL4SEUnit** wire_wCounterin3210 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterin3210");

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or98 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or98");
	objectCall3(binop_or98, Connect, 0, wire_wCounterin[9], 0);
	objectCall3(binop_or98, Connect, 1, wire_wCounterin[8], 0);
	objectCall3(wire_wCounterin98, Connect, 0, binop_or98, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or76 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or76");
	objectCall3(binop_or76, Connect, 0, wire_wCounterin[7], 0);
	objectCall3(binop_or76, Connect, 1, wire_wCounterin[6], 0);
	objectCall3(wire_wCounterin76, Connect, 0, binop_or76, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or54 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or54");
	objectCall3(binop_or54, Connect, 0, wire_wCounterin[5], 0);
	objectCall3(binop_or54, Connect, 1, wire_wCounterin[4], 0);
	objectCall3(wire_wCounterin54, Connect, 0, binop_or54, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or32 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or32");
	objectCall3(binop_or32, Connect, 0, wire_wCounterin[3], 0);
	objectCall3(binop_or32, Connect, 1, wire_wCounterin[2], 0);
	objectCall3(wire_wCounterin32, Connect, 0, binop_or32, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or10 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or10");
	objectCall3(binop_or10, Connect, 0, wire_wCounterin[1], 0);
	objectCall3(binop_or10, Connect, 1, wire_wCounterin[0], 0);
	objectCall3(wire_wCounterin10, Connect, 0, binop_or10, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or7654 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or7654");
	objectCall3(binop_or7654, Connect, 0, binop_or76, 0);
	objectCall3(binop_or7654, Connect, 1, binop_or54, 0);
	objectCall3(wire_wCounterin7654, Connect, 0, binop_or7654, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_OR);
	IHDL4SEUnit** binop_or3210 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or3210");
	objectCall3(binop_or3210, Connect, 0, binop_or32, 0);
	objectCall3(binop_or3210, Connect, 1, binop_or10, 0);
	objectCall3(wire_wCounterin3210, Connect, 0, binop_or3210, 2);

	IHDL4SEUnit** wire_wirein_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "3", "wirein_bCounterChanged");
	IHDL4SEUnit** wire_wireout_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "3", "wireout_bCounterChanged");
	IHDL4SEUnit** reg_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "3", "reg_bCounterChanged");
	objectCall3(reg_bCounterChanged, Connect, 0, wire_wirein_bCounterChanged, 0);
	objectCall3(wire_wireout_bCounterChanged, Connect, 0, reg_bCounterChanged, 1);

	IHDL4SEUnit** wire_bChanged_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "3", "bChanged_if_nwReset");
	IHDL4SEUnit** bind_wCounterin = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1, 1, 1", "bind_wCounterin");
	objectCall3(bind_wCounterin, Connect, 0, wire_wCounterin3210, 0);
	objectCall3(bind_wCounterin, Connect, 1, wire_wCounterin7654, 0);
	objectCall3(bind_wCounterin, Connect, 2, wire_wCounterin98, 0);
	objectCall3(wire_bChanged_if_nwReset, Connect, 0, bind_wCounterin, 3);

	IHDL4SEUnit** wire_b3b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "3", "b3b0");
	IHDL4SEUnit** const_b3b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "3, 0", "const_b3b0");
	objectCall3(wire_b3b0, Connect, 0, const_b3b0, 0);
	IHDL4SEUnit** mux_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "3", "mux_if_nwReset");
	objectCall3(mux_if_nwReset, Connect, 0, wire_b3b0, 0);
	objectCall3(mux_if_nwReset, Connect, 1, wire_bChanged_if_nwReset, 0);
	objectCall3(wire_wirein_bCounterChanged, Connect, 0, mux_if_nwReset, 2);

	IHDL4SEUnit** wire_wCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterChanged0");
	IHDL4SEUnit** wire_wCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterChanged1");
	IHDL4SEUnit** wire_wCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wCounterChanged2");
	IHDL4SEUnit** split4_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_SPLIT4, 
		         "3, 1, 0, 1, 1, 1,2, 1,2", "split4_bCounterChanded");
	objectCall3(split4_bCounterChanged, Connect, 0, wire_wireout_bCounterChanged, 0);
	objectCall3(wire_wCounterChanged0, Connect, 0, split4_bCounterChanged, 1);
	objectCall3(wire_wCounterChanged1, Connect, 0, split4_bCounterChanged, 2);
	objectCall3(wire_wCounterChanged2, Connect, 0, split4_bCounterChanged, 3);

	IHDL4SEUnit** wire_wirein_wWrite = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wirein_wWrite");
	IHDL4SEUnit** wire_wireout_wWrite = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wireout_wWrite");
	IHDL4SEUnit** reg_wWrite = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "1", "reg_wWrite");
	objectCall3(reg_wWrite, Connect, 0, wire_wirein_wWrite, 0);
	objectCall3(wire_wireout_wWrite, Connect, 0, reg_wWrite, 1);

	IHDL4SEUnit** wire_wirein_bWriteAddr = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wirein_bWriteAddr");
	IHDL4SEUnit** wire_wireout_bWriteAddr = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wireout_bWriteAddr");
	IHDL4SEUnit** reg_bWriteAddr = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "32", "reg_bWriteAddr");
	objectCall3(reg_bWriteAddr, Connect, 0, wire_wirein_bWriteAddr, 0);
	objectCall3(wire_wireout_bWriteAddr, Connect, 0, reg_bWriteAddr, 1);

	IHDL4SEUnit** wire_wirein_bWriteData = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wirein_bWriteData");
	IHDL4SEUnit** wire_wireout_bWriteData = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wireout_bWriteData");
	IHDL4SEUnit** reg_bWriteData = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "32", "reg_bWriteData");
	objectCall3(reg_bWriteData, Connect, 0, wire_wirein_bWriteData, 0);
	objectCall3(wire_wireout_bWriteData, Connect, 0, reg_bWriteData, 1);

	IHDL4SEUnit** wire_wirein_bWriteMask = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wirein_bWriteMask");
	IHDL4SEUnit** wire_wireout_bWriteMask = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wireout_bWriteMask");
	IHDL4SEUnit** reg_bWriteMask = hdl4seCreateUnit(module_main, CLSID_HDL4SE_REG, "4", "reg_bWriteMask");
	objectCall3(reg_bWriteMask, Connect, 0, wire_wirein_bWriteMask, 0);
	objectCall3(wire_wireout_bWriteMask, Connect, 0, reg_bWriteMask, 1);

	IHDL4SEUnit** wire_b8b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "8", "b8b0");
	IHDL4SEUnit** const_b8b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "8, 0", "const_b8b0");
	objectCall3(wire_b8b0, Connect, 0, const_b8b0, 0);

	IHDL4SEUnit** wire_b4b0000 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "b4b0000");
	IHDL4SEUnit** const_b4b0000 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "4, 0", "const_b4b0000");
	objectCall3(wire_b4b0000, Connect, 0, const_b4b0000, 0);

	IHDL4SEUnit** wire_b4b1100 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "b4b1100");
	IHDL4SEUnit** const_b4b1100 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "4, 4'b1100", "const_b4b1100");
	objectCall3(wire_b4b1100, Connect, 0, const_b4b1100, 0);

	IHDL4SEUnit** wire_b32b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b32b0");
	IHDL4SEUnit** const_b32b0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "32, 0", "const_b32b0");
	objectCall3(wire_b32b0, Connect, 0, const_b32b0, 0);

	IHDL4SEUnit** wire_b32hf0000018 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b32hf0000018");
	IHDL4SEUnit** const_b32hf0000018 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "32, 32'hf0000018", "const_b32hf0000018");
	objectCall3(wire_b32hf0000018, Connect, 0, const_b32hf0000018, 0);

	IHDL4SEUnit** wire_b32hf0000014 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b32hf0000014");
	IHDL4SEUnit** const_b32hf0000014 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "32, 32'hf0000014", "const_b32hf0000014");
	objectCall3(wire_b32hf0000014, Connect, 0, const_b32hf0000014, 0);

	IHDL4SEUnit** wire_b32hf0000010 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b32hf0000010");
	IHDL4SEUnit** const_b32hf0000010 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_CONST, "32, 32'hf0000010", "const_b32hf0000010");
	objectCall3(wire_b32hf0000010, Connect, 0, const_b32hf0000010, 0);

	IHDL4SEUnit** wire_b0098 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b0098");
	IHDL4SEUnit** wire_b7654 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b7654");
	IHDL4SEUnit** wire_b3210 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "b3210");

	IHDL4SEUnit** bind4_b0098 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BIND4, "8,8,8,8", "bind_0098");
	objectCall3(bind4_b0098, Connect, 0, code[8], 0);
	objectCall3(bind4_b0098, Connect, 1, code[9], 0);
	objectCall3(bind4_b0098, Connect, 2, wire_b8b0, 0);
	objectCall3(bind4_b0098, Connect, 3, wire_b8b0, 0);
	objectCall3(wire_b0098, Connect, 0, bind4_b0098, 4);

	IHDL4SEUnit** bind4_b7654 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BIND4, "8,8,8,8", "bind_7654");
	objectCall3(bind4_b7654, Connect, 0, code[4], 0);
	objectCall3(bind4_b7654, Connect, 1, code[5], 0);
	objectCall3(bind4_b7654, Connect, 2, code[6], 0);
	objectCall3(bind4_b7654, Connect, 3, code[7], 0);
	objectCall3(wire_b7654, Connect, 0, bind4_b7654, 4);

	IHDL4SEUnit** bind4_b3210 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BIND4, "8,8,8,8", "bind_3210");
	objectCall3(bind4_b3210, Connect, 0, code[0], 0);
	objectCall3(bind4_b3210, Connect, 1, code[1], 0);
	objectCall3(bind4_b3210, Connect, 2, code[2], 0);
	objectCall3(bind4_b3210, Connect, 3, code[3], 0);
	objectCall3(wire_b3210, Connect, 0, bind4_b3210, 4);

	IHDL4SEUnit** wire_bWriteMask_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wire_bWriteMask_if_bCounterChanged0");
	IHDL4SEUnit** mux_bWriteMask_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "4", "mux_bWriteMask_if_bCounterChanged0");
	objectCall3(mux_bWriteMask_if_bCounterChanged0, Connect, 0, wire_wireout_bWriteMask, 0);
	objectCall3(mux_bWriteMask_if_bCounterChanged0, Connect, 1, wire_b4b0000, 0);
	objectCall3(wire_bWriteMask_if_bCounterChanged0, Connect, 0, mux_bWriteMask_if_bCounterChanged0, 2);

	IHDL4SEUnit** wire_bWriteAddr_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteAddr_if_bCounterChanged0");
	IHDL4SEUnit** mux_bWriteAddr_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteAddr_if_bCounterChanged0");
	objectCall3(mux_bWriteAddr_if_bCounterChanged0, Connect, 0, wire_wireout_bWriteAddr, 0);
	objectCall3(mux_bWriteAddr_if_bCounterChanged0, Connect, 1, wire_b32hf0000010, 0);
	objectCall3(wire_bWriteAddr_if_bCounterChanged0, Connect, 0, mux_bWriteAddr_if_bCounterChanged0, 2);

	IHDL4SEUnit** wire_bWriteData_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteData_if_bCounterChanged0");
	IHDL4SEUnit** mux_bWriteData_if_bCounterChanged0 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteData_if_bCounterChanged0");
	objectCall3(mux_bWriteData_if_bCounterChanged0, Connect, 0, wire_wireout_bWriteData, 0);
	objectCall3(mux_bWriteData_if_bCounterChanged0, Connect, 1, wire_b3210, 0);
	objectCall3(wire_bWriteData_if_bCounterChanged0, Connect, 0, mux_bWriteData_if_bCounterChanged0, 2);

	IHDL4SEUnit** wire_bWriteMask_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wire_bWriteMask_if_bCounterChanged1");
	IHDL4SEUnit** mux_bWriteMask_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "4", "mux_bWriteMask_if_bCounterChanged1");
	objectCall3(mux_bWriteMask_if_bCounterChanged1, Connect, 0, mux_bWriteMask_if_bCounterChanged0, 0);
	objectCall3(mux_bWriteMask_if_bCounterChanged1, Connect, 1, wire_b4b0000, 0);
	objectCall3(wire_bWriteMask_if_bCounterChanged1, Connect, 0, mux_bWriteMask_if_bCounterChanged1, 2);

	IHDL4SEUnit** wire_bWriteAddr_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteAddr_if_bCounterChanged1");
	IHDL4SEUnit** mux_bWriteAddr_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteAddr_if_bCounterChanged1");
	objectCall3(mux_bWriteAddr_if_bCounterChanged1, Connect, 0, mux_bWriteAddr_if_bCounterChanged0, 0);
	objectCall3(mux_bWriteAddr_if_bCounterChanged1, Connect, 1, wire_b32hf0000014, 0);
	objectCall3(wire_bWriteAddr_if_bCounterChanged1, Connect, 0, mux_bWriteAddr_if_bCounterChanged1, 2);

	IHDL4SEUnit** wire_bWriteData_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteData_if_bCounterChanged1");
	IHDL4SEUnit** mux_bWriteData_if_bCounterChanged1 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteData_if_bCounterChanged1");
	objectCall3(mux_bWriteData_if_bCounterChanged1, Connect, 0, mux_bWriteData_if_bCounterChanged0, 0);
	objectCall3(mux_bWriteData_if_bCounterChanged1, Connect, 1, wire_b7654, 0);
	objectCall3(wire_bWriteData_if_bCounterChanged1, Connect, 0, mux_bWriteData_if_bCounterChanged1, 2);

	IHDL4SEUnit** wire_bWriteMask_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wire_bWriteMask_if_bCounterChanged2");
	IHDL4SEUnit** mux_bWriteMask_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "4", "mux_bWriteMask_if_bCounterChanged2");
	objectCall3(mux_bWriteMask_if_bCounterChanged2, Connect, 0, mux_bWriteMask_if_bCounterChanged1, 0);
	objectCall3(mux_bWriteMask_if_bCounterChanged2, Connect, 1, wire_b4b1100, 0);
	objectCall3(wire_bWriteMask_if_bCounterChanged2, Connect, 0, mux_bWriteMask_if_bCounterChanged2, 2);

	IHDL4SEUnit** wire_bWriteAddr_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteAddr_if_bCounterChanged2");
	IHDL4SEUnit** mux_bWriteAddr_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteAddr_if_bCounterChanged2");
	objectCall3(mux_bWriteAddr_if_bCounterChanged2, Connect, 0, mux_bWriteAddr_if_bCounterChanged1, 0);
	objectCall3(mux_bWriteAddr_if_bCounterChanged2, Connect, 1, wire_b32hf0000018, 0);
	objectCall3(wire_bWriteAddr_if_bCounterChanged2, Connect, 0, mux_bWriteAddr_if_bCounterChanged2, 2);

	IHDL4SEUnit** wire_bWriteData_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteData_if_bCounterChanged2");
	IHDL4SEUnit** mux_bWriteData_if_bCounterChanged2 = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteData_if_bCounterChanged2");
	objectCall3(mux_bWriteData_if_bCounterChanged2, Connect, 0, mux_bWriteData_if_bCounterChanged1, 0);
	objectCall3(mux_bWriteData_if_bCounterChanged2, Connect, 1, wire_b0098, 0);
	objectCall3(wire_bWriteData_if_bCounterChanged2, Connect, 0, mux_bWriteData_if_bCounterChanged2, 2);

	IHDL4SEUnit** wire_bWriteMask_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "4", "wire_bWriteMask_if_nwReset");
	IHDL4SEUnit** mux_bWriteMask_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "4", "mux_bWriteMask_if_nwReset");
	objectCall3(mux_bWriteMask_if_nwReset, Connect, 0, mux_bWriteMask_if_bCounterChanged2, 0);
	objectCall3(mux_bWriteMask_if_nwReset, Connect, 1, wire_b4b0000, 0);
	objectCall3(wire_wirein_bWriteMask, Connect, 0, mux_bWriteMask_if_nwReset, 2);

	IHDL4SEUnit** wire_bWriteAddr_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteAddr_if_nwReset");
	IHDL4SEUnit** mux_bWriteAddr_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteAddr_if_nwReset");
	objectCall3(mux_bWriteAddr_if_nwReset, Connect, 0, mux_bWriteAddr_if_bCounterChanged2, 0);
	objectCall3(mux_bWriteAddr_if_nwReset, Connect, 1, wire_b32b0, 0);
	objectCall3(wire_wirein_bWriteAddr, Connect, 0, mux_bWriteAddr_if_nwReset, 2);

	IHDL4SEUnit** wire_bWriteData_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "32", "wire_bWriteData_if_nwReset");
	IHDL4SEUnit** mux_bWriteData_if_nwReset = hdl4seCreateUnit(module_main, CLSID_HDL4SE_MUX2, "32", "mux_bWriteData_if_nwReset");
	objectCall3(mux_bWriteData_if_nwReset, Connect, 0, mux_bWriteData_if_bCounterChanged2, 0);
	objectCall3(mux_bWriteData_if_nwReset, Connect, 1, wire_b32b0, 0);
	objectCall3(wire_wirein_bWriteData, Connect, 0, mux_bWriteData_if_nwReset, 2);

	IHDL4SEUnit** wire_or_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_WIRE, "1", "wire_or_bCounterChanged");
	sprintf(temp, "3, 1, %d", UNOP_OR);
	IHDL4SEUnit** or_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_UNOP, temp, "or_bCounterChanged");
	objectCall3(or_bCounterChanged, Connect, 0, wire_wireout_bCounterChanged, 0);
	objectCall3(wire_or_bCounterChanged, Connect, 0, or_bCounterChanged, 2);

	sprintf(temp, "1, 1, 1, %d", BINOP_AND);
	IHDL4SEUnit** and_nwReset_bCounterChanged = hdl4seCreateUnit(module_main, CLSID_HDL4SE_BINOP, temp, "or_bCounterChanged");
	objectCall3(and_nwReset_bCounterChanged, Connect, 0, wire_or_bCounterChanged, 0);
	objectCall3(and_nwReset_bCounterChanged, Connect, 1, unit_main, 0); /*nwReset*/
	objectCall3(wire_wirein_wWrite, Connect, 0, and_nwReset_bCounterChanged, 2);


	/*ͷmoduleӿ*/
	objectRelease(module_main);
	/*unitӿ*/
	return unit_main;
}
